bullet = {}
bullet.width = 5
bullet.height = 5
bullet.speed = 750
bullet.recoil = 20

function bullet.spawn(x,y,dir,visible)
	table.insert(bullet, {x = x, y = y, dir = dir, width = bullet.width, height = bullet.height})
end
--
function bullet.draw()
	for i,v in ipairs(bullet) do
		if v.x > 0 and v.x + bullet.width < screenWidth and v.y > 0 
		and v.y + bullet.height < screenHeight then
			love.graphics.setColor(70,128,51)
			love.graphics.rectangle("fill", v.x, v.y, bullet.width, bullet.height)
		else
			table.remove(bullet, i)
		end 
	end
end
--
function bullet.move(dt)
	for i,v in ipairs(bullet) do
		if v.dir == "up" then
			v.y = v.y - bullet.speed * dt
		end
		if v.dir == "down" then
			v.y = v.y + bullet.speed * dt
		end
		if v.dir == "right" then
			v.x = v.x + bullet.speed * dt
		end
		if v.dir == "left" then
			v.x = v.x - bullet.speed * dt
		end
	end
end

--PARENT FUNCTIONS
function DRAW_BULLET()
	bullet.draw()
end
function UPDATE_BULLET(dt)
	bullet.move(dt)
end