enemy = {}
enemy.timer = 0
enemy.timerLim = love.math.random(3,5)
enemy.amount = love.math.random(3,5)
enemy.side = love.math.random(1,4)
--
function enemy.generate(dt)
	enemy.timer = enemy.timer + dt
	if enemy.timer > enemy.timerLim then
		for i=1,enemy.amount do
			if enemy.side == 1 then --Left
				enemy.spawn(-50, screenHeight / 2 - 25)
			end
			if enemy.side == 2 then --Top
				enemy.spawn(screenWidth / 2 - 25, -50)
			end
			if enemy.side == 3 then --Right
				enemy.spawn(screenWidth, screenHeight / 2 - 25)
			end
			if enemy.side == 4 then --Bottom
				enemy.spawn(screenWidth / 2 - 25, screenHeight)
			end
			enemy.side = love.math.random(1,4)
		end
		enemy.amount = love.math.random(1,3)
		enemy.timerLim = love.math.random(3,5)
		enemy.timer = 0
	end
end

enemy.width = 50
enemy.height = 50
enemy.speed = 1000
enemy.friction = 7.5
--
function enemy.spawn(x,y)
	table.insert(enemy, {x = x, y = y, xvel = 0, yvel = 0, health = 2, width = enemy.width, height = enemy.height})
end
--
function enemy.physics(dt)		
	for i,v in ipairs(enemy) do
		if player.x + player.width > v.x and player.x < v.x + v.width and player.y + player.height > v.y and player.y < v.y + v.height then
			v.xvel = 0
			v.yvel = 0
		end

		v.x = v.x + v.xvel * dt
		v.y = v.y + v.yvel * dt
		v.xvel = v.xvel * (1 - math.min(dt*enemy.friction, 1))
		v.yvel = v.yvel * (1 - math.min(dt*enemy.friction, 1))
	end
end
--
function enemy.AI(dt)
	for i,v in ipairs(enemy) do
		--X axis
		if player.x + player.width / 2 < v.x + v.width / 2 then
			if v.xvel > -enemy.speed then
				v.xvel = v.xvel - enemy.speed * dt
			end
		end
		if player.x + player.width / 2 > v.x + v.width / 2 then
			if v.xvel < enemy.speed then
				v.xvel = v.xvel + enemy.speed * dt
			end
		end
		--Y axis
		if player.y + player.height / 2 < v.y + v.height / 2 then
			if v.yvel > -enemy.speed then
				v.yvel = v.yvel - enemy.speed * dt
			end
		end
		if player.y + player.height / 2 > v.y + v.height / 2 then
			if v.yvel < enemy.speed then
				v.yvel = v.yvel + enemy.speed * dt
			end
		end
	end
end
--
function enemy.bullet_collide()
	for i,v in ipairs(enemy) do
		for ia,va in ipairs(bullet) do
			if va.x + va.width > v.x and
			va.x < v.x + v.width and
			va.y + va.height > v.y and
			va.y < v.y + v.height then
				print(v.health)
				v.health = v.health - 1
				if v.health == -2 then
					table.remove(enemy, i)
					table.remove(bullet, ia)
				end 
			end
		end
	end
end
--
function enemy.draw()
	for i,v in ipairs(enemy) do
		love.graphics.setColor(189,82,201)
		love.graphics.rectangle("fill", v.x, v.y, v.width, v.height)
	end
end

--PARENT FUNCTIONS
function DRAW_ENEMY()
	enemy.draw()
end
function UPDATE_ENEMY(dt)
	enemy.AI(dt)
--	enemy.generate(dt)
	enemy.bullet_collide()
	enemy.physics(dt)
end